
      PROGRAM TZHEEV5
*
*          PZHEEV5
*
      include 'mpif.h'
*   -   ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, LRWORK,
     $                   LIWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 50, LWORK = 17, LIWORK = 42,
     $                   LRWORK = 63,
*      PARAMETER          ( LDA = 100, LWORK = -1, LIWORK = -1,
*     $                   LRWORK = -1,
     $                   MAXN = 50, MAXPROCS = 512, NOUT =6,
     $                   ZERO = 0.0D+0, MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*
*   ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB,
     $                   NPCOL, NPROCS, NPROW, IA, JA, IL, IU
      DOUBLE PRECISION   ABSTOL
*
*   ..
      INTEGER            DESCA( 9 ), IWORK( LIWORK )
*      INTEGER            DESCA( 9 ), IWORK( 42 )

      DOUBLE PRECISION   W( MAXN ), RWORK( LRWORK )
*      DOUBLE PRECISION   RWORK( 63 ), W( MAXN )
*
      DOUBLE COMPLEX     A( LDA, LDA ), WORK1( 7 ),
     $                   WORK( LWORK )
*     $                   WORK( 17 )
*
*   ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PZLAPRNT,
     $                   PZHEEV5, PDLAMCH
*
*   ..
*
*  
*
      N = 7
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IL = 2
      IU = 7
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
      ABSTOL = 2.0D0* PDLAMCH(CTXT,'U')
*
*     A
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
*   A
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) '   '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = 9995 ) IL, IU
         WRITE( NOUT, FMT = 9993 ) ABSTOL
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
 9995 FORMAT( / ' IL = ', I5, ' IU = ', I5 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 /)
*
      CALL PZLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
*   
*
      CALL PZHEEV5( UPLO, N, A, IA, JA, DESCA, IL, IU, ABSTOL, M, W,
     $              WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9986 )M
*         WRITE( NOUT, FMT = 9986 )WORK(1), IWORK(1), RWORK(1)
         WRITE( NOUT, FMT = * ) '  '
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
      END IF
*
      CALL BLACS_GRIDEXIT( CTXT )
*
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '   PZHEEV5' )
 9998 FORMAT( / '      A',
     $       '    ( IL, IU ),' //
     $      '  A -   ',
     $      I2, '  ', I2,',',
     $       '   ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9996 FORMAT( / '  INFO  = ', I3)
* 9986 FORMAT( / ' WORK(1) =',(D16.5, D16.5), ' IWORK(1) =', I3,
*     $       '  RWORK(1) =', D16.5 /)
 9986 FORMAT( / ' M  = ', I3 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT     A   
*
*   - 
      INTEGER            DLEN_, CTXT_
      PARAMETER          ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE COMPLEX     ONE
      PARAMETER          ( ONE = (1.0D+0, 0.0D0) )
*
*  - 
      INTEGER            IA, INFO, JA, N
*
*  - 
      INTEGER            DESCA( * )
      DOUBLE COMPLEX     A( * )
*
*  
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
*
*  
      EXTERNAL           BLACS_GRIDINFO, PZELSET
*
*  
      INTRINSIC          DBLE
*
*  
*
      INFO = 0
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PZELSET( A, I, J, DESCA, (0.0D0, 0.0D0) )
    1 CONTINUE
    2 CONTINUE
      DO 4 J = 1, N
      DO 3 I = 1, N
         IF( I.EQ.J ) THEN
            CALL PZELSET( A, I, J, DESCA, 1.0D0)
         END IF
    3 CONTINUE
    4 CONTINUE
      J = N
      DO 5 I = 1, N
      CALL PZELSET( A, I, J, DESCA, DCMPLX( DBLE(I), 0.0D0) )
    5 CONTINUE
      I = N         
      DO 6 J = 1, N
      CALL PZELSET( A, I, J, DESCA, DCMPLX( DBLE(J), 0.0D0) )
    6 CONTINUE
*
      RETURN
*
*     End of PDMATINIT
*
      END
